#include "Motor.h"

static int export_fd, direction_fd, gpiovalue_fd;

static int Motor_GPIO_Init();
static int Motor_GPIO_Function();
static int Motor_GPIO_File_FOK();
static int PWM_GPIO_File_FOK();

int Motor_PWM_Init(PWMBaseInitTypeDef PWM_BaseStructure)
{
    char PWM_Function_Set[10] = {0}; 
    int String_file_len = 0;
    //1、检查文件存在
    if(-1 == PWM_GPIO_File_FOK())
    {
        printf("PWM_GPIO_File creat Faild\n");
        return -1;
    }
    //2、设置PWM属性
    String_file_len = sprintf(PWM_Function_Set,"%d",PWM_BaseStructure.period);//周期:单位 ns
    //printf("period %ld\n",PWM_BaseStructure.period);
    direction_fd = open("/sys/class/pwm/pwmchip0/pwm7/period", O_WRONLY);
    if(-1 == direction_fd)
    {
        printf("[%s]:[%d] open gpio direction file error\r\n", __FUNCTION__, __LINE__);
        
        return -1;
    }
    if(-1 == write(direction_fd, PWM_Function_Set, String_file_len))
    {
        printf("[%s]:[%d] write operation direction error\r\n", __FUNCTION__, __LINE__);
        close(direction_fd);
        return -1;
    }
    close(direction_fd);

    String_file_len = sprintf(PWM_Function_Set,"%d",PWM_BaseStructure.duty_cycle);//占空比 / ns 
    //printf("duty_cycle %ld\n",PWM_BaseStructure.duty_cycle);
    direction_fd = open("/sys/class/pwm/pwmchip0/pwm7/duty_cycle", O_WRONLY);
    if(-1 == direction_fd)
    {
        printf("[%s]:[%d] open gpio direction file error\r\n", __FUNCTION__, __LINE__);
        
        return -1;
    }
    if(-1 == write(direction_fd, PWM_Function_Set, String_file_len))
    {
        printf("[%s]:[%d] write operation direction error\r\n", __FUNCTION__, __LINE__);
        close(direction_fd);
        return -1;
    }
    close(direction_fd);

    if(PWM_BaseStructure.polarity){
        direction_fd = open("/sys/class/pwm/pwmchip0/pwm7/polarity", O_WRONLY);
        if(-1 == direction_fd)
        {
            printf("[%s]:[%d] open gpio direction file error\r\n", __FUNCTION__, __LINE__);
            
            return -1;
        }
        if(-1 == write(direction_fd, "normal", sizeof("normal")))
        {
            printf("[%s]:[%d] write operation direction error\r\n", __FUNCTION__, __LINE__);
            close(direction_fd);
            return -1;
        }
        close(direction_fd);
    }
    else{
        direction_fd = open("/sys/class/pwm/pwmchip0/pwm7/polarity", O_WRONLY);
        if(-1 == direction_fd)
        {
            printf("[%s]:[%d] open gpio direction file error\r\n", __FUNCTION__, __LINE__);
            
            return -1;
        }
        if(-1 == write(direction_fd, "inversed", sizeof("inversed")))
        {
            printf("[%s]:[%d] write operation direction error\r\n", __FUNCTION__, __LINE__);
            close(direction_fd);
            return -1;
        }
        close(direction_fd);
    }

    // 3、IO file open return fd*
    PWM_GPIO_fd = open(PWN_PATH, O_WRONLY);  //RDWR
    if(-1 == PWM_GPIO_fd)
    {
        printf("[%s]:[%d]: open value file error\r\n", __FUNCTION__, __LINE__);
        return -1;
    }
    //write(PWM_GPIO_fd, "1", 1);
    return 1;
}
int Motor_PWM_Set(int enable){
    if(enable){
        PWM_OutPut_ENABLE;
    }
    else{
        PWM_OutPut_DISABLE;
    }
}

int Motor_Init(){
    //1、检查文件是否存在 4 个 GPIO 都需要检查.
    if(-1 == Motor_GPIO_File_FOK()){
        printf("Motor_GPIO_File creat Faild\n");
        return -1;
    }
    //2、设置IO功能为 out 
    if(-1 == Motor_GPIO_Function()){
        printf("Motor_GPIO_Function set Faild \n");
        return -1;
    }
    //3、IO file open return fd*
    if(-1 == Motor_GPIO_Init()){
        printf("Motor_GPIO_File Open Faild \n");
        return -1;
    }
    return 1;
}
void MotorCW( void )
{
    unsigned char i;
    unsigned char temp = 0;
    for( i = 0; i < 4; i++ )
    {
        temp = phasecw[i];

        // LD = ( temp >> 3 ) & 0x01;							//取bit4的值
        // LC = ( temp >> 2 ) & 0x01;
        // LB = ( temp >> 1 ) & 0x01;
        // LA = ( temp >> 0 ) & 0x01;							//取bit0的值
        GPIO_WrietPin(GPIO_Point_IN1, ( temp >> 3 ) & 0x01);
        GPIO_WrietPin(GPIO_Point_IN2, ( temp >> 2 ) & 0x01);
        GPIO_WrietPin(GPIO_Point_IN3, ( temp >> 1 ) & 0x01);
        GPIO_WrietPin(GPIO_Point_IN4, ( temp >> 0 ) & 0x01);
        delay_ms(2); 										
    }
    MotorStop();
}
void MotorStop( void )
{
    GPIO_Point_IN1_ReSet;
    GPIO_Point_IN2_ReSet;
    GPIO_Point_IN3_ReSet;
    GPIO_Point_IN4_ReSet;
}

int GPIO_WrietPin(int GPIO_Point,int GPIO_Value){
    if(!(GPIO_Value == 0 || GPIO_Value == 1)){
        printf("GPIO_Value Faild %d \n",GPIO_Value);
        return -1;
    }
    switch(GPIO_Point){
        case GPIO_Point_IN1:
            //GPIO_WRITEPIN(GPIO_Point_IN1_fd,GPIO_Value);
            if(GPIO_Value) GPIO_Point_IN1_Set;
            else GPIO_Point_IN1_ReSet;
            break;
        case GPIO_Point_IN2:
            //GPIO_WRITEPIN(GPIO_Point_IN2_fd,GPIO_Value);
            if(GPIO_Value) GPIO_Point_IN2_Set;
            else GPIO_Point_IN2_ReSet;
            break;
        case GPIO_Point_IN3:
            //GPIO_WRITEPIN(GPIO_Point_IN3_fd,GPIO_Value);
            if(GPIO_Value) GPIO_Point_IN3_Set;
            else GPIO_Point_IN3_ReSet;
            break;
        case GPIO_Point_IN4:
            //GPIO_WRITEPIN(GPIO_Point_IN4_fd,GPIO_Value);
            if(GPIO_Value) GPIO_Point_IN4_Set;
            else GPIO_Point_IN4_ReSet;
            break;
        default:
            break;
    }

}
static int PWM_GPIO_File_FOK(){
    //char gpio_file_path[40] = {0}; 
    if(access(PWN_PATH,F_OK)){
        printf("PWM File not find creat it! \n");
        export_fd = open("/sys/class/pwm/pwmchip0/export", O_WRONLY);
        if(-1 == export_fd)
        {
                printf("[%s]:[%d] open gpio export file error\r\n", __FUNCTION__, __LINE__);
                return -1;
        }
        if(-1 == write(export_fd, "7", 1))
        {
                printf("write file operation error\r\n");
                return -1;
        }
        close(export_fd);
    }
    return 1;
}


static int Motor_GPIO_File_FOK(){

    char gpio_file_path[40] = {0}; 
    char gpio_Point_File_Num[4] = {0};

    sprintf(gpio_file_path,GPIO_PATH,GPIO_Point_IN1);
    sprintf(gpio_Point_File_Num,"%d",GPIO_Point_IN1);
    if(access(gpio_file_path,F_OK)){
        printf("GPIO [%d] not find creat it! \n ",GPIO_Point_IN1);

        export_fd = open("/sys/class/gpio/export", O_WRONLY);
        if(-1 == export_fd)
        {
                printf("[%s]:[%d] open gpio export file error\r\n", __FUNCTION__, __LINE__);
                return -1;
        }
        if(-1 == write(export_fd, gpio_Point_File_Num, 4))
        {
                printf("write file operation error\r\n");
                return -1;
        }
        close(export_fd);
    }

    sprintf(gpio_file_path,GPIO_PATH,GPIO_Point_IN2);
    sprintf(gpio_Point_File_Num,"%d",GPIO_Point_IN2);
    if(access(gpio_file_path,F_OK)){
        printf("GPIO [%d] not find creat it! \n ",GPIO_Point_IN2);

        export_fd = open("/sys/class/gpio/export", O_WRONLY);
        if(-1 == export_fd)
        {
                printf("[%s]:[%d] open gpio export file error\r\n", __FUNCTION__, __LINE__);
                return -1;
        }
        if(-1 == write(export_fd, gpio_Point_File_Num, 4))
        {
                printf("write file operation error\r\n");
                return -1;
        }
        close(export_fd);
    }

    sprintf(gpio_file_path,GPIO_PATH,GPIO_Point_IN3);
    sprintf(gpio_Point_File_Num,"%d",GPIO_Point_IN3);
    if(access(gpio_file_path,F_OK)){
        printf("GPIO [%d] not find creat it! \n ",GPIO_Point_IN3);

        export_fd = open("/sys/class/gpio/export", O_WRONLY);
        if(-1 == export_fd)
        {
                printf("[%s]:[%d] open gpio export file error\r\n", __FUNCTION__, __LINE__);
                return -1;
        }
        if(-1 == write(export_fd, gpio_Point_File_Num, 4))
        {
                printf("write file operation error\r\n");
                return -1;
        }
        close(export_fd);
    }

    sprintf(gpio_file_path,GPIO_PATH,GPIO_Point_IN4);
    sprintf(gpio_Point_File_Num,"%d",GPIO_Point_IN4);
    if(access(gpio_file_path,F_OK)){
        printf("GPIO [%d] not find creat it! \n ",GPIO_Point_IN4);

        export_fd = open("/sys/class/gpio/export", O_WRONLY);
        if(-1 == export_fd)
        {
                printf("[%s]:[%d] open gpio export file error\r\n", __FUNCTION__, __LINE__);
                return -1;
        }
        if(-1 == write(export_fd, gpio_Point_File_Num, 4))
        {
                printf("write file operation error\r\n");
                return -1;
        }
        close(export_fd);
    }
    return 1;
}


static int Motor_GPIO_Function(){
    char GPIO_Function_Path[40] = {0};
    sprintf(GPIO_Function_Path,GPIO_FUNCTION_PATH,GPIO_Point_IN1);
    direction_fd = open(GPIO_Function_Path, O_WRONLY);
    if(-1 == direction_fd)
    {
        printf("[%s]:[%d] open gpio direction file error\r\n", __FUNCTION__, __LINE__);
        
        return -1;
    }
    if(-1 == write(direction_fd, "out", sizeof("out")))
    {
        printf("[%s]:[%d] write operation direction error\r\n", __FUNCTION__, __LINE__);
        close(direction_fd);
        return -1;
    }
    close(direction_fd);

     sprintf(GPIO_Function_Path,GPIO_FUNCTION_PATH,GPIO_Point_IN2);
    direction_fd = open(GPIO_Function_Path, O_WRONLY);
    if(-1 == direction_fd)
    {
        printf("[%s]:[%d] open gpio direction file error\r\n", __FUNCTION__, __LINE__);
        
        return -1;
    }
    if(-1 == write(direction_fd, "out", sizeof("out")))
    {
        printf("[%s]:[%d] write operation direction error\r\n", __FUNCTION__, __LINE__);
        close(direction_fd);
        return -1;
    }
    close(direction_fd);

     sprintf(GPIO_Function_Path,GPIO_FUNCTION_PATH,GPIO_Point_IN3);
    direction_fd = open(GPIO_Function_Path, O_WRONLY);
    if(-1 == direction_fd)
    {
        printf("[%s]:[%d] open gpio direction file error\r\n", __FUNCTION__, __LINE__);
        
        return -1;
    }
    if(-1 == write(direction_fd, "out", sizeof("out")))
    {
        printf("[%s]:[%d] write operation direction error\r\n", __FUNCTION__, __LINE__);
        close(direction_fd);
        return -1;
    }
    close(direction_fd);

     sprintf(GPIO_Function_Path,GPIO_FUNCTION_PATH,GPIO_Point_IN4);
    direction_fd = open(GPIO_Function_Path, O_WRONLY);
    if(-1 == direction_fd)
    {
        printf("[%s]:[%d] open gpio direction file error\r\n", __FUNCTION__, __LINE__);
        
        return -1;
    }
    if(-1 == write(direction_fd, "out", sizeof("out")))
    {
        printf("[%s]:[%d] write operation direction error\r\n", __FUNCTION__, __LINE__);
        close(direction_fd);
        return -1;
    }
    close(direction_fd);

    return 1;
}
// int GPIO_Point_IN1_fd;
// int GPIO_Point_IN2_fd;
// int GPIO_Point_IN3_fd;
// int GPIO_Point_IN4_fd;
static int Motor_GPIO_Init(){

    char gpio_file_path[40] = {0}; 

    sprintf(gpio_file_path,GPIO_PATH,GPIO_Point_IN1);
    GPIO_Point_IN1_fd = open(gpio_file_path, O_WRONLY);  //RDWR
    if(-1 == GPIO_Point_IN1_fd)
    {
        printf("[%s]:[%d]: open value file error\r\n", __FUNCTION__, __LINE__);
        return -1;
    }

    sprintf(gpio_file_path,GPIO_PATH,GPIO_Point_IN2);
    GPIO_Point_IN2_fd = open(gpio_file_path, O_WRONLY);  //RDWR
    if(-1 == GPIO_Point_IN2_fd)
    {
        printf("[%s]:[%d]: open value file error\r\n", __FUNCTION__, __LINE__);
        return -1;
    }

    sprintf(gpio_file_path,GPIO_PATH,GPIO_Point_IN3);
    GPIO_Point_IN3_fd = open(gpio_file_path, O_WRONLY);  //RDWR
    if(-1 == GPIO_Point_IN3_fd)
    {
        printf("[%s]:[%d]: open value file error\r\n", __FUNCTION__, __LINE__);
        return -1;
    }

    sprintf(gpio_file_path,GPIO_PATH,GPIO_Point_IN4);
    GPIO_Point_IN4_fd = open(gpio_file_path, O_WRONLY);  //RDWR
    if(-1 == GPIO_Point_IN4_fd)
    {
        printf("[%s]:[%d]: open value file error\r\n", __FUNCTION__, __LINE__);
        return -1;
    }
    return 1;
}
